/* copyleft GPL  (see file COPYING)
 *
 * au: vitas (vitas@popelka.ms.mff.cuni.cz)
 */

/*
 *
 *  kompozice obrazku
 *  
 *  darken	= <ro * RGB, A >
 *  fade	= <delta * RGB, delta * A>
 *  opaque	= <RGB, omega * A>
 *  
 *  plus	= <RGB1 + RGB2, A1 + A2 >
 *
 *		Fa	Fb
 *  atop	A2	1 - A1
 *  xor		1 - A2	1 - A1
 *  over	1	1 - A1
 *  in		A1	0
 *  heldoutby	1 - A2	0
 *  
 *  <RGB1 * Fa + RGB2 * Fb, A1 * Fa + A2 * Fb>
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "alf.h"
#include "yy.h"

float alf_time= 0;
float alf_time_delta= 0;
int alf_frame= -1;
int alf_frames= -1;
int alf_y_siz = 256;
int alf_x_siz = 256; 

int scr_siz;

t_line alf_line[ALF_LINE_SIZ];
int alf_line_top = 0;

t_pic alf_pic[ALF_PIC_SIZ];
int alf_pic_top = 0;

t_rgba rgba_0={0,0,0,0};


t_parse *new_p(int typ, t_parse *le, t_parse *ri)
{

  t_parse *ret;

  ret=(t_parse*) malloc(sizeof(t_parse));
  ret->typ= typ;
  ret->le= le;
  ret->ri= ri;


  return ret;

} /* new_p */

void next_line(char *pic, t_parse *par)
{
  if(alf_line_top == ALF_LINE_SIZ)
  { /* *alf_line[]* je preplneno */
    printf("next_line(): prilis mnoho radek (%i)\n", alf_line_top);
    exit(-1);
  }

  alf_line[alf_line_top].pic= pic;
  alf_line[alf_line_top].par= par;

  alf_line_top++;

} /* next_line_top */

void set_id(char id, float val)
{

  printf("id %c == %f\n", id, val);
  switch( id )
  {
  case 'x': alf_x_siz= val; break; 
  case 'y': alf_y_siz= val; break; 
  case 'e': alf_frames= val; break;
  case 's': alf_frame= val; break;
  default: printf("! unknownd id (%c == %f) ignored\n", id, val);
  }
} /* set_id */

int add_pic(char *pic)
{
  int i;

  /* nejprve jestli uz tento obrazek nemame */

  for(i= alf_pic_top; i--;)
  {
    if( ! strcmp( alf_pic[i].pic, pic ) )
    { /* je to v poradku, uz tam je */
      return i;
    }
  }

  /* zarad nove jmeno do seznamu */
      
  if(alf_pic_top >= ALF_PIC_SIZ)
  { /* *alf_pic[]* je preplneno */
    printf("next_pic(): prilis mnoho obrazku(%i)\n", alf_pic_top);
    exit(-1);
  }

  alf_pic[alf_pic_top].pic= pic;

  /* zvetsi *alf_pic_top* ale vrat pave vyplneny prvek */
  return alf_pic_top++;
    
} /* add_pic */	

void prsp(int zanor)
{
  for(;zanor--;)printf(" ");
}
 

void print_par(int sp, t_parse *par)
{
  prsp(sp);
  switch(par->typ)
  {
  case T_PIC:
    printf("pic(%s)\n", alf_pic[(int)par->val].pic);
    break;

  case T_OPPP_OVE:
  case T_OPPP_ATO:
  case T_OPPP_INN:
  case T_OPPP_XOR:
  case T_OPPP_HEL:

  case T_OPPP_PLU:

  case T_OPPA_DAR:
  case T_OPPA_OPA:
  case T_OPPA_FAD:
  case T_OPPA_ALF:

  case T_OPAA_ADD:
  case T_OPAA_SUB:
  case T_OPAA_MUL:
  case T_OPAA_DIV:
    printf("op(%i)\n", (int)par->typ);
    print_par(sp+1, par->le);
    print_par(sp+1, par->ri);
    break;

  case T_NUM:
    printf("num(%f)\n", par->val);
    break;

  case T_TIME:
    printf("time(%f)\n", alf_time);
    break;

  case T_FRAME:
    printf("frame(%i)\n", alf_frame);
    break;

  case T_FRAMES:
    printf("frames(%i)\n", alf_frames);
    break;

  default:
    printf("neake nezname pars:%i(%f)", par->typ, par->val);
    exit(-1);
  }
} /* print_par */
 
int yywrap(){return 1;} /* yywrap */

int yyerror(char *s)
{
  printf("%s (bf %s) (a nereknu kde)\n", s, yytext);
  exit(-1);
} /* yyerror */

t_rgba *eval_pexpr(t_parse *par)
{
  t_rgba *sri, *sle;
  switch(par->typ)
  {
  case T_OPPP_OVE:
    sle= eval_pexpr(par->le);
    sri= eval_pexpr(par->ri);
    sle= alfa_ove(sle, sri);
    break;

  case T_OPPP_ATO:
    sle= eval_pexpr(par->le);
    sri= eval_pexpr(par->ri);
    sle= alfa_ato(sle, sri);
    break;

  case T_OPPP_INN:
    sle= eval_pexpr(par->le);
    sri= eval_pexpr(par->ri);
    sle= alfa_inn(sle, sri);
    break;

  case T_OPPP_XOR:
    sle= eval_pexpr(par->le);
    sri= eval_pexpr(par->ri);
    sle= alfa_xor(sle, sri);
    break;

  case T_OPPP_HEL:
    sle= eval_pexpr(par->le);
    sri= eval_pexpr(par->ri);
    sle= alfa_hel(sle, sri);
    break;

  case T_OPPP_PLU:
    sle= eval_pexpr(par->le);
    sri= eval_pexpr(par->ri);
    sle= alfa_plu(sle, sri);
    break;

  case T_OPPA_DAR:
    return alfa_dar(eval_pexpr(par->le), eval_expr(par->ri)/100.);

  case T_OPPA_OPA:
    return alfa_opa(eval_pexpr(par->le), eval_expr(par->ri)/100.);

  case T_OPPA_FAD:
    return alfa_fad(eval_pexpr(par->le), eval_expr(par->ri)/100.);

  case T_OPPA_ALF:
    return alfa_alf(eval_pexpr(par->le), eval_expr(par->ri)/100.);

  case T_PIC:
    return alfa_pic(par->val);

  default:
    printf("eval_pexpr:nezname pars:%i(%f)", par->typ, par->val);
    exit(-1);
  }

  free(sri);
  printf("free\n");
  return sle;
} /* eval_pexpr */

double eval_expr(t_parse *par)
{
  switch(par->typ)
  {
  case T_OPAA_ADD:
    return eval_expr(par->le) + eval_expr(par->ri);

  case T_OPAA_SUB:
    return eval_expr(par->le) - eval_expr(par->ri);

  case T_OPAA_MUL:
    return eval_expr(par->le) * eval_expr(par->ri);

  case T_OPAA_DIV:
    return eval_expr(par->le) / eval_expr(par->ri);
    
  case T_NUM:
    return par->val;

  case T_TIME:
    return  alf_time * 100.;

  case T_FRAME:
    return alf_frame;

  case T_FRAMES:
    return alf_frames;

  default:
    printf("eval_expr:nezname pars:%i(%f)", par->typ, par->val);
    exit(-1);
  }
} /* eval_expr */


void alf_roznasob(t_rgba *s)
/*
 * interval <0,255> => <0.0, 0.1> a zaroven provede alfa * RGB
 */
{
  int i;
  float alfa;


  for(i= scr_siz;i--;)
  {
    alfa=
    s[i].a= ( s[i].a ) / 256.0;

    s[i].r= s[i].r / 255.0;
    s[i].g= s[i].g / 255.0;
    s[i].b= s[i].b / 255.0;
  }
} /* alf_roznasob */
    
void alf_vydel(t_rgba *s)
/*
 * prevadi <aRGB, a> --> <RGB, a>
 * rozsah <0,1> se meni na <0, 255> (i kdyz stale floaty ale cela cisla)
 * kdyz je RGB > 255 da tam 255
 * kdyz je <aRGB, 0> --> <RGB, 0> (no co bys stim chtel delat)
 */
{
  int i;
  float alfa;
  float r, g, b, a;


  for(i= scr_siz; i--;)
  {
    alfa= s[i].a;

      r= (s[i].r * 255.0 );
      g= (s[i].g * 255.0 );
      b= (s[i].b * 255.0 );

      s[i].r= r<=255?r:255;
      s[i].g= g<=255?g:255;
      s[i].b= b<=255?b:255;
    a= alfa * 256.0;
    s[i].a= (a<=255?a:255);
  }
} /* alf_vydel */
    
  
t_rgba *alfa_pic(int idx)
/*
 * a: idx index do tabulky  *alf_pic[]* ktereze to jmeno je
 */

{
  t_rgba *ret;
  FILE *f;
  int rd;
  char *name;
  int i;


  name= alf_pic[idx].pic;

  printf("alfa_pic:name:%s(%i)\n", name, idx);

  f= fopen(name, "rb");

  if( f == NULL )
  {
    printf("alf_pic: canntot fopen(%s)\n", name);
  }

  ret= scr_new();

#define READ_SLOZKU(x) for(i=0;i<scr_siz;i++)\
                         if( -1 == (ret[i].x=getc(f)) )ret[i].x= 255.0;


  READ_SLOZKU(r);
  READ_SLOZKU(g);
  READ_SLOZKU(b);
  READ_SLOZKU(a);

  alf_roznasob(ret);

  return ret;
} /* alfa_pic */

void alf_prepare_name(char *ret, char *name)
{
  char *dot;

  if( alf_frame >= 0 )
  {
    dot= rindex(name, '.');
    if( dot != NULL )
    {
      *dot= '\0';
      sprintf(ret, "%s%03i.%s", name, alf_frame, dot + 1);
      *dot= '.';
      return;
    }
  }
  strcpy(ret, name);
} /* alf_prepare_name */

void alf_pic_save(char *name, t_rgba *s)
{
  FILE *f;
  int i;

  char realname[100];

  alf_prepare_name(realname, name);
  
  if( !(f= fopen(realname, "w")) )
  {
    printf("cannot fopen(%s, \"w\")\n", name);
    exit(-1);
  }
#define WRITE_SLOZKU(x) for(i=0;i<scr_siz;i++)fputc(s[i].x,f);

  alf_vydel(s);

  WRITE_SLOZKU(r);
  WRITE_SLOZKU(g);
  WRITE_SLOZKU(b);
  WRITE_SLOZKU(a);

} /* alf_pic_save */
  

t_rgba *scr_new()
{
  t_rgba *ret;

  printf("scr_new\n");
  ret=(t_rgba*) malloc( scr_siz * sizeof(t_rgba) );
  if( !ret )
  {
    printf("scr_new: malloc failed.");
    exit(-1);
  }
  return ret;
} /* scr_new */
  
  

void usage()
{
  printf(
  "usage: alf  < alf.in \n"
  "  images will be procesed as said in alf.in\n\n",
  "  alt comes with *absolutely no warranty* and this is free soft\n"
  "  and you are welcome to redistribute it under conditions of gpl\n"
  "  (for more info see /usr/docs/*/COPYING\n" );
  exit(-1);
} /* usage */

void alf_run()
{
  int i;
  t_rgba *scr;
  for(i= 0; i < alf_line_top; i++)
  {
    scr= eval_pexpr(alf_line[i].par);
    alf_pic_save(alf_line[i].pic, scr); 
    free(scr);
    printf("free\n");
  }
} /* alf_run */

int main(int argc, char *argv[])
{
  
  if( argc != 1 ) 
  {
    usage();
  }
#if 0
  if( sscanf(argv[1], "%dx%d", &x_res, &y_res) != 2 )
  {
    usage();
  }

#endif

  yyparse();

  scr_siz= alf_x_siz * alf_y_siz;

  printf("%ix%i---\n", alf_x_siz, alf_y_siz);
  print_par(0, alf_line[0].par);
  printf("---\n");
  alf_time_delta= 1.0 / alf_frames;
  for(;alf_frame <= alf_frames; alf_frame++)
  {
    alf_run();
    alf_time+= alf_time_delta;
    printf("done [%i/%i]\n", alf_frame, alf_frames);
  }
  return 0;
} /* main */

/*************************************************************************
 *
 * 
 *  a konecne alfa kanaly
 * 
 * 
 */


t_rgba *alfa_dar(t_rgba *s, float ro)
/*
 *  <ro * RGB, a>
 */

{
  int i;

  for(i= scr_siz; i--;)
  {
    s[i].r*= ro;
    s[i].g*= ro;
    s[i].b*= ro;
  }
  return s;
} /* alfa_dar */


t_rgba *alfa_fad(t_rgba *s, float delta)
/*
 * <delta * RGB, delta * a>
 */
{
  int i;

  for(i= scr_siz; i--;)
  {
    s[i].r*= delta;
    s[i].g*= delta;
    s[i].b*= delta;
    s[i].a*= delta;
  }
  return s;
} /* alfa_fad */


t_rgba *alfa_opa(t_rgba *s, float omega)
/*
 * <RGB, omega * a>
 */
{
  int i;

  printf("in opaque(om:%f)[%f]\n", omega, s[1].a);
  for(i= scr_siz; i--;)
  {
    s[i].a*= omega;
  }
  return s;
} /* alfa_fad */

t_rgba *alfa_alf(t_rgba *s, float alfa)
{
  int i;
  for(i= scr_siz; i--;)
  {
    s[i].a= alfa;
  }
  return s;
} /* alfa_alf */

t_rgba *alfa_ato(t_rgba *s1, t_rgba *s2)
/*
 * Fa= alfa_b
 * Fb= 1 - alfa_a
 */ 
{
  int i;
  int a;

  float Fa, Fb;

  for( i = scr_siz; i--;)
  {
    Fa= s1[i].a * (1 - s2[i].a);
    Fb= s1[i].a * s2[i].a;

    s1[i].r= s1[i].r * Fa + s2[i].r * Fb;
    s1[i].g= s1[i].g * Fa + s2[i].g * Fb; s1[i].b= s1[i].b * Fa + s2[i].b * Fb;
    s1[i].a= s1[i].a * Fa + s2[i].a * Fb;
  }
  return s1;
} /* alfa_ato */

t_rgba *alfa_xor(t_rgba *s1, t_rgba *s2)
{
  int i;

  float Fa, Fb;

  printf("xor: s1[0].a=%f\n", s2[0].a);

  for( i = scr_siz; i--;)
  {
    Fa= s1[i].a * ( 1 - s2[i].a);
    Fb= (1 - s1[i].a) * s2[i].a;

    s1[i].r= s1[i].r * Fa + s2[i].r * Fb;
    s1[i].g= s1[i].g * Fa + s2[i].g * Fb;
    s1[i].b= s1[i].b * Fa + s2[i].b * Fb;
    s1[i].a= s1[i].a * Fa + s2[i].a * Fb;
  }
  return s1;
} /* alfa_xor */

t_rgba *alfa_ove(t_rgba *s1, t_rgba *s2)
{
  int i;
  float Fa, Fb;


  for( i = scr_siz; i--;)
  {
    Fa= s1[i].a;
    Fb= (1 - s1[i].a) * s2[i].a;

    s1[i].r= s1[i].r * Fa + s2[i].r * Fb;
    s1[i].g= s1[i].g * Fa + s2[i].g * Fb;
    s1[i].b= s1[i].b * Fa + s2[i].b * Fb;
    s1[i].a= s1[i].a * Fa + s2[i].a * Fb;

  }
  return s1;
} /* alfa_atop */

t_rgba *alfa_inn(t_rgba *s1, t_rgba *s2)
{
  int i;
  float Fa;


  for( i = scr_siz; i--;)
  {
    Fa= s1[i].a * s2[i].a;


    s1[i].r= s1[i].r * Fa;
    s1[i].g= s1[i].g * Fa;
    s1[i].b= s1[i].b * Fa;
    s1[i].a= s1[i].a * Fa;

  }

  return s1;
} /* alfa_atop */

t_rgba *alfa_hel(t_rgba *s1, t_rgba *s2)
{
  int i;

  float  Fa, Fb;


  for( i = scr_siz; i--;)
  {
    Fa= s1[i].a * (1 - s2[i].a);

    s1[i].r= s1[i].r * Fa;
    s1[i].g= s1[i].g * Fa;
    s1[i].b= s1[i].b * Fa;
    s1[i].a= s1[i].a * Fa;

  }
  return s1;
} /* alfa_hel */


t_rgba *alfa_plu(t_rgba *s1, t_rgba *s2)
{

  int i;
  float a1ku2, a2ku1;

  for(i= scr_siz; i--;)
  {

    s1[i].r= s1[i].r + s2[i].r;
    s1[i].g= s1[i].g + s2[i].g;
    s1[i].b= s1[i].b + s2[i].b;
    s1[i].a= s1[i].a + s2[i].a;

  }
  return s1;
} /* alfa_plu */


