#ifndef __ALF_H_
#define __ALF_H_

#define ALF_LINE_SIZ 30
#define ALF_PIC_SIZ 30

#define T_OPAA_ADD 20
#define T_OPAA_SUB 21
#define T_OPAA_MUL 22
#define T_OPAA_DIV 23

#define T_OPPA_DAR 30
#define T_OPPA_OPA 31
#define T_OPPA_FAD 32
#define T_OPPA_ALF 33

#define T_OPPP_OVE 40
#define T_OPPP_ATO 41
#define T_OPPP_INN 42
#define T_OPPP_XOR 43
#define T_OPPP_HEL 44

#define T_OPPP_PLU 50



typedef struct {
#if 1
  float r, g, b, a;
#else
  unsigned char a, r, g, b;
#endif
} t_rgba;

struct t_parse {
  int typ;
  struct t_parse *le, *ri;
  float val;
};

typedef struct t_parse t_parse;

struct t_line {
  char    *pic;
  t_parse *par;
};

typedef struct t_line t_line;

struct t_pic {
  char *pic;
  /* jeste necosi */
};

typedef struct t_pic t_pic;

t_parse *new_p(int   type, t_parse *le, t_parse *ri);

void next_line(char *pic , t_parse *par);
void set_id(char c, float val);
int  add_pic(char *pic);

extern char *yytext;
int yywrap();
int yyerror(char *s);

t_rgba *alfa_pic(int idx);

t_rgba *alfa_ove(t_rgba *s1, t_rgba *s2);
t_rgba *alfa_ato(t_rgba *s1, t_rgba *s2);
t_rgba *alfa_inn(t_rgba *s1, t_rgba *s2);
t_rgba *alfa_xor(t_rgba *s1, t_rgba *s2);
t_rgba *alfa_hel(t_rgba *s1, t_rgba *s2);

t_rgba *alfa_plu(t_rgba *s1, t_rgba *s2);

t_rgba *alfa_dar(t_rgba *s, float ro);
t_rgba *alfa_opa(t_rgba *s, float ro);
t_rgba *alfa_fad(t_rgba *s, float ro);
t_rgba *alfa_alf(t_rgba *s, float alfa);

t_rgba *eval_pexpr(t_parse *par);
double eval_expr (t_parse *par);
t_rgba *scr_new();

#endif
