%{
#include <string.h>
#include "alf.h"
#include "yy.h"

#if 0
# define DB(n) 
#else
# define DB(n) printf("lex:(%s)[%i]\n", yytext, n);
#endif
%}

NUM	[0-9]+

PIC	[a-z][[:alnum:]\./]*

ID	"-"[a-z]

%%

{NUM}	{ DB(9); yylval.num= atof(yytext); return T_NUM; }
{ID}	{ DB(17);yylval.num= yytext[1]; return T_ID; 	 }

darken	{ DB(0); yylval.num= T_OPPA_DAR; return T_OPPA; }
opaque	{ DB(1); yylval.num= T_OPPA_OPA; return T_OPPA; }
fade	{ DB(2); yylval.num= T_OPPA_FAD; return T_OPPA; }
alfa	{ DB(16);yylval.num= T_OPPA_ALF; return T_OPPA; }

over	{ DB(3); yylval.num= T_OPPP_OVE; return T_OPPP; }
atop	{ DB(4); yylval.num= T_OPPP_ATO; return T_OPPP; }
in	{ DB(5); yylval.num= T_OPPP_INN; return T_OPPP; }
xor	{ DB(6); yylval.num= T_OPPP_XOR; return T_OPPP; }
heldout	{ DB(7); yylval.num= T_OPPP_HEL; return T_OPPP; }

plus	{ DB(15); yylval.num= T_OPPP_PLU; return T_OPPP; }

\%f	{ DB(12); return T_FRAME;  }
\%F	{ DB(13); return T_FRAMES; }
\%t	{ DB(14); return T_TIME;   }

{PIC}	{ DB(8); yylval.str= strdup(yytext); return T_PIC;  }

[ \t\n]+ /* eat white */
#.*$	/* eat comment */
.	{ DB(33); return *yytext; }
%%
