%{

#include "alf.h"

#if 0
# define DB(m)
#else
# define DB(m) printf("yy:(%s)\n", m);
#endif


%}

%union {

char	*str;
t_parse	*prs;
float	num;

}


%type  <prs> n_pexpr n_expr
%token <str> T_PIC
%token <num> T_NUM T_ID
%token <num> T_OPPP T_OPPA

%token T_FRAME T_FRAMES T_TIME

%left T_OPPP 
%left T_OPPA

%left '+' '-'
%left '*' '/'
%%

input
	: /* empty */
	| input n_line
	;

n_line
	: T_PIC '=' n_pexpr ';'		{ next_line( $1, $3 ); DB("n_line"); }
	| T_ID T_NUM			{ set_id((char)$1, $2 ); printf("%f", $2); DB("n_line(id)"); }
	;

n_pexpr
	: '(' n_pexpr ')'		{ $$=$2; }
	| n_pexpr T_OPPP n_pexpr	{ $$= new_p($2, $1, $3); }
	| n_pexpr T_OPPA n_expr		{ $$= new_p($2, $1, $3); }
	| T_PIC				{
					  $$= new_p(T_PIC, 0, 0);
					  $$->val= add_pic($1);
					  DB("T_PIC");
					}
	;

n_expr
	: '(' n_expr ')'	{ $$= $2; }
	| n_expr '+' n_expr  	{ $$= new_p(T_OPAA_ADD, $1, $3); }
	| n_expr '-' n_expr  	{ $$= new_p(T_OPAA_SUB, $1, $3); }
	| n_expr '*' n_expr  	{ $$= new_p(T_OPAA_MUL, $1, $3); }
	| n_expr '/' n_expr 	{ $$= new_p(T_OPAA_DIV, $1, $3); }
	| T_TIME		{ $$= new_p(T_TIME,   0, 0); }
	| T_FRAME		{ $$= new_p(T_FRAME,  0, 0); }
	| T_FRAMES		{ $$= new_p(T_FRAMES, 0, 0); }
	| T_NUM			{ $$= new_p(T_NUM,    0, 0);
				  $$->val=$1;DB("NUM")
				}
	;
%%

