#include <stdio.h>
#include <stdlib.h>

typedef struct { unsigned char r, g, b, a; } t_rgba;

int tp, bt, lf, rg;
int sizex, sizey;

int alfa;
int pic_siz;

t_rgba *scr;

int read_scr(FILE *f, t_rgba *scr, int siz)
{
  for(;siz--;scr++)
  {
    fread(scr, 3, 1, f);
    scr->a= 0xff;
  }
} /* read_scr */

 
void draw_rect()
{
  int x; 
  int y;

  for(x=tp; x<=bt; x++)
  {
    for(y=lf; y<=rg; y++)
    {
      scr[x + y * sizex].a= alfa;
    }
  }
} /* draw_rext */
  

void usage()
{
  printf("usage: rect  NNxNN!alfa[tp,bt,lf,rg] in out - udela obdelnik\n");
  exit(0);
}

int main(int argc, char *argv[])
{

  FILE *f;

  if(argc != 4 )
  {
     usage();
  }

  if( sscanf(argv[1],
             "%dx%d@%d[%d,%d,%d,%d]",
	     &sizex, &sizey, &alfa, &tp, &bt, &lf, &rg ) != 7)
  {
    printf("bad number of args in argv[1]\n");
    usage();
  }

  
  pic_siz= sizex * sizey;

  scr= (t_rgba*) malloc( pic_siz * sizeof(t_rgba) );

  if( !(f= fopen(argv[2], "r") ) )
  {
    printf("cannot fopen(%s, \"r\")\n", argv[2]);
    return -1;
  }

  read_scr(f, scr, pic_siz);

  fclose(f);


  draw_rect();

  if( ! (f= fopen(argv[3], "wb") ) )
  {
    printf("cannot fopen(%s, \"w\")\n", argv[3]);
    return -1;
  }

  fwrite(scr, sizeof(t_rgba), pic_siz,  f);

  close(f);

} /* main */
